var ControllablesMixin, callbackName, capFirst, getControllableValue, invariant;

invariant = require('react/lib/invariant');

getControllableValue = function(name, state, props) {
  var _ref;
  return (_ref = props[name]) != null ? _ref : state[name];
};

capFirst = function(str) {
  return "" + (str.slice(0, 1).toUpperCase()) + str.slice(1);
};

callbackName = function(prop) {
  return "on" + (capFirst(prop)) + "Change";
};

ControllablesMixin = {
  getInitialState: function() {
    var defaultValue, name, state, _i, _len, _ref;
    invariant(!!this.controllables, 'Components that use ControllablesMixin must define a controllables array');
    state = {};
    _ref = this.controllables;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      name = _ref[_i];
      defaultValue = this.props["default" + (capFirst(name))];
      if (defaultValue != null) {
        state[name] = defaultValue;
      }
    }
    return state;
  },
  getControllableValue: function(name) {
    return getControllableValue(name, this.state, this.props);
  },
  componentDidUpdate: function(prevProps, prevState) {
    var name, newValue, oldValue, _base, _i, _len, _name, _ref;
    _ref = this.controllables;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      name = _ref[_i];
      newValue = this.state[name];
      if (newValue === prevState[name]) {
        continue;
      }
      oldValue = getControllableValue(name, prevState, prevProps);
      if (typeof (_base = this.props)[_name = callbackName(name)] === "function") {
        _base[_name](newValue, oldValue);
      }
    }
  }
};

module.exports = ControllablesMixin;
